'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var jsxRuntime = require('react/jsx-runtime');
var React = require('react');
var MuiAlert = require('@mui/material/Alert');
var Slide = require('@mui/material/Slide');
var Snackbar = require('@mui/material/Snackbar');
var material = require('@mui/material');
var Box = require('@mui/material/Box');
var styles$1 = require('@mui/material/styles');
var LinearProgress = require('@mui/material/LinearProgress');
var reactI18next = require('react-i18next');
var i18next = require('i18next');
var Button = require('@mui/material/Button');
var Dialog = require('@mui/material/Dialog');
var DialogActions = require('@mui/material/DialogActions');
var DialogContent = require('@mui/material/DialogContent');
var DialogContentText = require('@mui/material/DialogContentText');
var DialogTitle = require('@mui/material/DialogTitle');
var Stack = require('@mui/material/Stack');
var reactFontawesome = require('@fortawesome/react-fontawesome');
var fontawesomeSvgCore = require('@fortawesome/fontawesome-svg-core');
var freeSolidSvgIcons = require('@fortawesome/free-solid-svg-icons');
var Typography = require('@mui/material/Typography');
var Grid = require('@mui/material/Grid');
var Popover = require('@mui/material/Popover');
var Paper = require('@mui/material/Paper');
var IconButton = require('@mui/material/IconButton');
var CloseIcon = require('@mui/icons-material/Close');
var MobileDatePicker = require('@mui/x-date-pickers/MobileDatePicker');
var LocalizationProvider = require('@mui/x-date-pickers/LocalizationProvider');
var AdapterMoment = require('@mui/x-date-pickers/AdapterMoment');
var TextField = require('@mui/material/TextField');
var moment = require('moment');
var Autocomplete = require('@mui/material/Autocomplete');
var CircularProgress = require('@mui/material/CircularProgress');
var ClickAwayListener = require('@mui/material/ClickAwayListener');
var PersonSearchIcon = require('@mui/icons-material/PersonSearch');
var MapTwoToneIcon = require('@mui/icons-material/MapTwoTone');
var CorporateFareIcon = require('@mui/icons-material/CorporateFare');
var CardHeader = require('@mui/material/CardHeader');
var Avatar = require('@mui/material/Avatar');
var LocationOnTwoToneIcon = require('@mui/icons-material/LocationOnTwoTone');
var colors = require('@mui/material/colors');
var toolkit = require('@reduxjs/toolkit');
var Divider = require('@mui/material/Divider');
var EditIcon = require('@mui/icons-material/Edit');
var TablePagination = require('@mui/material/TablePagination');
var useMediaQuery = require('@mui/material/useMediaQuery');
var Pagination = require('@mui/material/Pagination');
var iconsMaterial = require('@mui/icons-material');
var Tooltip = require('@mui/material/Tooltip');
var xDataGridPro = require('@mui/x-data-grid-pro');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var MuiAlert__default = /*#__PURE__*/_interopDefaultLegacy(MuiAlert);
var Slide__default = /*#__PURE__*/_interopDefaultLegacy(Slide);
var Snackbar__default = /*#__PURE__*/_interopDefaultLegacy(Snackbar);
var Box__default = /*#__PURE__*/_interopDefaultLegacy(Box);
var LinearProgress__default = /*#__PURE__*/_interopDefaultLegacy(LinearProgress);
var Button__default = /*#__PURE__*/_interopDefaultLegacy(Button);
var Dialog__default = /*#__PURE__*/_interopDefaultLegacy(Dialog);
var DialogActions__default = /*#__PURE__*/_interopDefaultLegacy(DialogActions);
var DialogContent__default = /*#__PURE__*/_interopDefaultLegacy(DialogContent);
var DialogContentText__default = /*#__PURE__*/_interopDefaultLegacy(DialogContentText);
var DialogTitle__default = /*#__PURE__*/_interopDefaultLegacy(DialogTitle);
var Stack__default = /*#__PURE__*/_interopDefaultLegacy(Stack);
var Typography__default = /*#__PURE__*/_interopDefaultLegacy(Typography);
var Grid__default = /*#__PURE__*/_interopDefaultLegacy(Grid);
var Popover__default = /*#__PURE__*/_interopDefaultLegacy(Popover);
var Paper__default = /*#__PURE__*/_interopDefaultLegacy(Paper);
var IconButton__default = /*#__PURE__*/_interopDefaultLegacy(IconButton);
var CloseIcon__default = /*#__PURE__*/_interopDefaultLegacy(CloseIcon);
var TextField__default = /*#__PURE__*/_interopDefaultLegacy(TextField);
var moment__default = /*#__PURE__*/_interopDefaultLegacy(moment);
var Autocomplete__default = /*#__PURE__*/_interopDefaultLegacy(Autocomplete);
var CircularProgress__default = /*#__PURE__*/_interopDefaultLegacy(CircularProgress);
var ClickAwayListener__default = /*#__PURE__*/_interopDefaultLegacy(ClickAwayListener);
var PersonSearchIcon__default = /*#__PURE__*/_interopDefaultLegacy(PersonSearchIcon);
var MapTwoToneIcon__default = /*#__PURE__*/_interopDefaultLegacy(MapTwoToneIcon);
var CorporateFareIcon__default = /*#__PURE__*/_interopDefaultLegacy(CorporateFareIcon);
var CardHeader__default = /*#__PURE__*/_interopDefaultLegacy(CardHeader);
var Avatar__default = /*#__PURE__*/_interopDefaultLegacy(Avatar);
var LocationOnTwoToneIcon__default = /*#__PURE__*/_interopDefaultLegacy(LocationOnTwoToneIcon);
var Divider__default = /*#__PURE__*/_interopDefaultLegacy(Divider);
var EditIcon__default = /*#__PURE__*/_interopDefaultLegacy(EditIcon);
var TablePagination__default = /*#__PURE__*/_interopDefaultLegacy(TablePagination);
var useMediaQuery__default = /*#__PURE__*/_interopDefaultLegacy(useMediaQuery);
var Pagination__default = /*#__PURE__*/_interopDefaultLegacy(Pagination);
var Tooltip__default = /*#__PURE__*/_interopDefaultLegacy(Tooltip);

const BorderLinearProgress = styles$1.styled((props) => {
    var _a;
    return (jsxRuntime.jsx(LinearProgress__default["default"], { variant: props.variant, value: props.value, color: (_a = props.color) !== null && _a !== void 0 ? _a : "info" }));
})(({ theme }) => ({
    height: 5,
    borderRadius: 5,
    [`&.${LinearProgress.linearProgressClasses.colorPrimary}`]: {
        backgroundColor: theme.palette.grey[theme.palette.mode === "light" ? 200 : 800],
    },
    [`& .${LinearProgress.linearProgressClasses.bar}`]: {
        borderRadius: 5,
        backgroundColor: theme.palette.mode === "light" ? "#1a90ff" : "#308fe8",
    },
}));

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z$4 = ".nonIntrusive--unkown {\n  position: absolute;\n  width: 30%;\n  bottom: 0;\n  right: 10px;\n}\n\n.IntrusiveIcon {\n  display: flex;\n  margin-top: 1rem;\n  justify-content: center;\n}";
var styles = {"nonIntrusive--unkown":"nonIntrusive--unkown","IntrusiveIcon":"IntrusiveIcon","nonIntrusive____unkown":"nonIntrusive--unkown"};
styleInject(css_248z$4);

var global = {
	cancel: "Cancel",
	ok: "Ok",
	unknown: "Unknown",
	"delete": "Delete"
};
var commonEn = {
	global: global
};

var entitiesEn = {
	
};

var nerdAppsMenu = {
	home: "Home",
	app_icon_alt: "App Icon"
};
var nerdDataGrid = {
	"export": "EXPORT",
	delete_rows: "Delete selected rows"
};
var nerdConfirm = {
	are_you_sure: "Are you sure ?",
	confirm: "I am sure",
	ask_confirmation: "Do you want to continue ? This action cannot be undone"
};
var nerdPagination = {
	next: "Next",
	first: "First",
	prev: "Prev",
	previous: "Previous",
	page: "Page"
};
var componentsEn = {
	nerdAppsMenu: nerdAppsMenu,
	nerdDataGrid: nerdDataGrid,
	nerdConfirm: nerdConfirm,
	nerdPagination: nerdPagination
};

const translations = {
    en: {
        common: commonEn,
        entities: entitiesEn,
        components: componentsEn,
    },
};

const i18n = i18next.createInstance({
    fallbackLng: "en-EN",
    debug: false,
    interpolation: {
        escapeValue: false, // not needed for react as it escapes by default
    },
    resources: translations,
    ns: ["entities", "common", "components"],
    defaultNS: "common",
});
i18n.use(reactI18next.initReactI18next).init();

let direction = undefined;
/**
 *
 * @param {NerdNotificationProps & openHookAction} param0 components props
 * @returns {JSX.Element} NonIntrusive nerdNotifier
 */
function NonIntrusive({ uuid, title, transition = "up", severity = "info", subtitle, body, position = {
    vertical: "bottom",
    horizontal: "right",
}, actions, autoHideDuration = 5000, autohide = true, open, handleClose, icon, color, }) {
    direction = transition;
    const [progress, setProgress] = React__default["default"].useState(0);
    const { t } = reactI18next.useTranslation("common", { i18n: i18n });
    const timer = React__default["default"].useRef(0);
    React__default["default"].useEffect(() => {
        timer.current = window.setInterval(() => {
            setProgress((prevProgress) => prevProgress >= 100 ? 0 : prevProgress + 10);
        }, autoHideDuration / 10);
        return () => {
            clearInterval(timer.current);
        };
    }, []);
    React__default["default"].useEffect(() => {
        if (progress >= 100 && autohide) {
            handleClose();
        }
    }, [progress, autohide]);
    if (icon) {
        return (jsxRuntime.jsx(Alert, Object.assign({ severity: "warning", className: `${styles["nonIntrusive--unkown"]}` }, { children: t("global.unknown") })));
    }
    return (jsxRuntime.jsx(Box__default["default"], Object.assign({ component: "div", id: uuid }, { children: jsxRuntime.jsx(Snackbar__default["default"], Object.assign({ open: open, autoHideDuration: autohide ? autoHideDuration : null, TransitionComponent: Transition, anchorOrigin: position }, { children: jsxRuntime.jsxs(material.Stack, Object.assign({ spacing: 1 }, { children: [autohide && (jsxRuntime.jsx(BorderLinearProgress, { variant: "determinate", value: progress, color: severity })), jsxRuntime.jsxs(Alert, Object.assign({ severity: severity, sx: { width: "100%", alignItems: "center", backgroundColor: color }, action: actions, onClose: handleClose }, { children: [title && jsxRuntime.jsx(material.Typography, Object.assign({ variant: "body1" }, { children: title })), subtitle && jsxRuntime.jsx(material.Typography, Object.assign({ variant: "body2" }, { children: subtitle })), body && jsxRuntime.jsx(material.Typography, Object.assign({ variant: "caption" }, { children: body }))] }))] })) })) })));
}
const Alert = React__default["default"].forwardRef(function Alert(props, ref) {
    return jsxRuntime.jsx(MuiAlert__default["default"], Object.assign({ ref: ref, variant: "filled" }, props));
});
/**
 *
 * @param {TransitionProps} props Component props
 * @returns {JSX.Element} Transition Component
 */
function Transition(props) {
    return jsxRuntime.jsx(Slide__default["default"], Object.assign({}, props, { direction: direction }));
}

fontawesomeSvgCore.library.add(freeSolidSvgIcons.fas);
/**
 * This component is a wrapper for the FontAwesomeIcon component.
 * It is used to add icons to any library. More info here: https://fontawesome.com/v5/docs/web/use-with/react
 */
const NerdIcon = (props) => {
    const { icon, severity, iconColor, size = "3x", onMouseEnter, onMouseLeave, } = props;
    if (!icon) {
        return null;
    }
    return (jsxRuntime.jsx("span", Object.assign({ onMouseEnter: onMouseEnter, onMouseLeave: onMouseLeave }, { children: typeof icon === "string" ? (setCustomIconString(Object.assign({ icon, severity, iconColor, size }))) : (jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, { icon: icon, size: size, color: iconColor !== null && iconColor !== void 0 ? iconColor : "#0288d1" })) })));
};
/**
 *
 * @param root0
 * @param root0.icon
 * @param root0.iconColor
 * @param root0.severity
 * @param root0.size
 */
function setCustomIconString({ icon, iconColor, severity, size = "3x", }) {
    return (jsxRuntime.jsx(reactFontawesome.FontAwesomeIcon, { icon: setCustomIconDefinition(icon), color: iconColor && iconColor !== ""
            ? iconColor
            : colorSwitch(severity || "info"), size: size }));
}
//TODO: fontawesome-svg-core package needs to be updated. (v5.15.4 current version). The icons name are were changed.
/**
 *
 * @param icon
 */
function setCustomIconDefinition(icon) {
    const iconLookup = {
        prefix: "fas",
        iconName: icon,
    };
    const customIconDefinition = fontawesomeSvgCore.findIconDefinition(iconLookup);
    return customIconDefinition;
}
/**
 *
 * @param color
 */
function colorSwitch(color) {
    switch (color) {
        case "error":
            return "#d32f2f";
        case "info":
            return "#0288d1";
        case "success":
            return "#2e7d32";
        case "warning":
            return "#ed6c02";
        default:
            return "#000";
    }
}

/**
 *
 * @param {NerdNotificationProps & openHookAction} param0 Component props
 * @returns {JSX.Element} Intrusive nerdNotifier
 */
function Intrusive({ title, subtitle, body, icon, actions, severity = "info", open, iconColor, autoHideDuration = 5000, autohide = true, showIcon = true, onHandleClose, unstyled = true, actionPrimaryProps = {
    variant: "text",
    color: "primary",
}, actionSecondaryProps = {
    variant: "text",
    color: "inherit",
}, }) {
    var _a;
    const [progress, setProgress] = React__default["default"].useState(0);
    const timer = React__default["default"].useRef(0);
    const { t } = reactI18next.useTranslation("common", { i18n: i18n });
    const handleClose = (_event, reason) => {
        if (reason === "clickaway" ||
            reason === "escapeKeyDown" ||
            reason === "backdropClick") {
            return;
        }
        onHandleClose(false);
    };
    React__default["default"].useEffect(() => {
        timer.current = window.setInterval(() => {
            setProgress((prevProgress) => prevProgress >= 100 ? 0 : prevProgress + 10);
        }, autoHideDuration / 10);
        return () => {
            clearInterval(timer.current);
        };
    }, []);
    React__default["default"].useEffect(() => {
        if (progress >= 100 && autohide) {
            onHandleClose(false);
        }
    }, [progress, autohide, open]);
    const severityIcon = setCustomIconDefinition(((_a = severityIcons(severity)) !== null && _a !== void 0 ? _a : "exclamation-circle"));
    return (jsxRuntime.jsx(Dialog__default["default"], Object.assign({ open: open, onClose: handleClose, "aria-labelledby": "alert-dialog-title", "aria-describedby": "alert-dialog-description", keepMounted: true, transitionDuration: 1000, classes: {
            paper: "NerdNotifierIntrusivePaper",
        } }, { children: jsxRuntime.jsxs(Stack__default["default"], Object.assign({ spacing: 1 }, { children: [autohide && !actions && (jsxRuntime.jsx(BorderLinearProgress, { variant: "determinate", value: progress, color: severity })), showIcon && (jsxRuntime.jsxs(Box__default["default"], Object.assign({ className: styles.IntrusiveIcon }, { children: [typeof icon === "string" ? (jsxRuntime.jsx(NerdIcon, { icon: severityIcon, severity: severity, iconColor: iconColor })) : (icon), severity && !icon && (jsxRuntime.jsx(NerdIcon, { icon: severityIcon, severity: severity, iconColor: colorSwitch(severity) }))] }))), title && jsxRuntime.jsx(DialogTitle__default["default"], Object.assign({ id: "alert-dialog-title" }, { children: title })), unstyled ? (jsxRuntime.jsxs(DialogContent__default["default"], { children: [subtitle && (jsxRuntime.jsx(DialogContentText__default["default"], Object.assign({ id: "alert-dialog-description" }, { children: subtitle }))), body] })) : (jsxRuntime.jsxs(React__default["default"].Fragment, { children: [subtitle, body] })), !autohide && (jsxRuntime.jsxs(DialogActions__default["default"], { children: [jsxRuntime.jsx(Button__default["default"], Object.assign({ onClick: handleClose }, actionSecondaryProps, { children: t("global.cancel") })), jsxRuntime.jsx(Button__default["default"], Object.assign({ onClick: handleClose }, actionPrimaryProps, { children: t("global.ok") }))] }))] })) })));
}
/**
 *
 * @param {string} severityText Severity text
 * @returns {string} Severity Icon
 */
function severityIcons(severityText) {
    switch (severityText) {
        case "error":
            return "times";
        case "info":
            return "exclamation";
        case "success":
            return "check";
        case "warning":
            return "exclamation-triangle";
        default:
            return "";
    }
}

const NerdNotifier = (props) => {
    const { notification, children, onClose } = props;
    const { variant = "non-intrusive", uuid } = notification;
    const [open, setOpen] = React__default["default"].useState(false);
    React__default["default"].useEffect(() => {
        if (uuid) {
            setOpen(true);
        }
    }, [uuid]);
    const handleClose = () => {
        setOpen(false);
        onClose === null || onClose === void 0 ? void 0 : onClose();
    };
    return (jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [children, variant === "non-intrusive" && open && (jsxRuntime.jsx(NonIntrusive, Object.assign({}, notification, { open: open, handleClose: handleClose }))), variant === "intrusive" && (jsxRuntime.jsx(Intrusive, Object.assign({}, notification, { open: open, onHandleClose: handleClose })))] }));
};

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

var css_248z$3 = ".font-size-xl {\n  font-size: 3.5rem;\n}\n\n.font-bold {\n  font-weight: 700;\n}";
styleInject(css_248z$3);

const NerdHeadingIcon = ({ icon, color, iconPosition, }) => {
    return (jsxRuntime.jsx(Grid__default["default"], Object.assign({ item: true, sx: { order: iconPosition === "left" ? 0 : 1, color: color } }, { children: icon })));
};

let theme = styles$1.createTheme({
    typography: {},
});
theme = styles$1.responsiveFontSizes(theme);
const ConditionalWrapper = ({ condition, wrapper, children, }) => (jsxRuntime.jsx(styles$1.ThemeProvider, Object.assign({ theme: theme }, { children: condition ? wrapper(children) : children })));

const NerdHeadingComposed = (props) => {
    const { text, display, variant, classes, icon, color, children, iconPosition = "left", spacing = 1, alignItems = "center", uppercase } = props, rest = __rest(props, ["text", "display", "variant", "classes", "icon", "color", "children", "iconPosition", "spacing", "alignItems", "uppercase"]);
    return (jsxRuntime.jsx(ConditionalWrapper, Object.assign({ condition: (text !== "" || typeof children === "string") && icon !== undefined, wrapper: (childrenContent) => (jsxRuntime.jsx(Grid__default["default"], Object.assign({ container: true, spacing: spacing, alignItems: alignItems }, { children: childrenContent }))) }, { children: jsxRuntime.jsxs(React__default["default"].Fragment, { children: [icon && jsxRuntime.jsx(NerdHeadingIcon, Object.assign({}, { icon, color, iconPosition })), typeof children === "object" && (jsxRuntime.jsx(NerdHeadingIcon, Object.assign({ icon: children }, { color, iconPosition }))), (typeof children === "string" || text) && (jsxRuntime.jsx(Grid__default["default"], Object.assign({ item: true }, { children: jsxRuntime.jsx(Typography__default["default"], Object.assign({ display: display, variant: variant, classes: classes, color: color, textTransform: uppercase ? "uppercase" : undefined }, rest, { children: typeof children === "string" ? children : text })) })))] }) })));
};

const NerdHeading = (props) => {
    const _a = props, { children, spacing, alignItems } = _a, rest = __rest(_a, ["children", "spacing", "alignItems"]);
    if (React.Children.count(children) > 0) {
        return (jsxRuntime.jsx(Grid__default["default"], Object.assign({ container: true, spacing: spacing, alignItems: alignItems }, { children: React.Children.map(children, (child) => {
                return jsxRuntime.jsx(NerdHeadingComposed, Object.assign({}, rest, { children: child }));
            }) })));
    }
    return jsxRuntime.jsx(NerdHeadingComposed, Object.assign({}, rest));
};

const NerdHelp = ({ explanation, classes, children, anchorOrigin = {
    vertical: "top",
    horizontal: "left",
}, transformOrigin = {
    vertical: "bottom",
    horizontal: "left",
}, variant = "body1", }) => {
    const [anchorEl, setAnchorEl] = React__default["default"].useState(null);
    const htmlRef = React.useRef(null);
    const open = Boolean(anchorEl);
    const onMouseEnter = () => {
        setAnchorEl(htmlRef.current);
    };
    const onMouseLeave = () => {
        setAnchorEl(null);
    };
    return (jsxRuntime.jsxs(React__default["default"].Fragment, { children: [jsxRuntime.jsx(Box__default["default"], Object.assign({ ref: htmlRef, onMouseEnter: onMouseEnter, onMouseLeave: onMouseLeave }, { children: children })), jsxRuntime.jsx(StyledPopover, Object.assign({ sx: {
                    pointerEvents: "none",
                }, open: open, anchorEl: anchorEl, anchorOrigin: anchorOrigin, transformOrigin: transformOrigin, classes: Object.assign({}, classes) }, { children: jsxRuntime.jsx(NerdHeading, { variant: variant, text: explanation, sx: { p: 1 } }) }))] }));
};
const StyledPopover = styles$1.styled(Popover__default["default"], {
    name: "StyledPopover",
    slot: "Wrapper",
})(() => ({
    width: "100%",
}));

const NerdCard = styles$1.styled(Paper__default["default"])(({ theme }) => ({
    borderRadius: theme.spacing(1),
    border: `solid 1px ${theme.palette.divider}`,
    padding: theme.spacing(2),
    borderLeft: `solid 4px ${theme.palette.primary.main}`,
    position: "relative",
    width: "100%",
}));

exports.InputAux = void 0;
(function (InputAux) {
    InputAux["REQUIRED"] = "required";
})(exports.InputAux || (exports.InputAux = {}));
exports.AutocompleteType = void 0;
(function (AutocompleteType) {
    AutocompleteType["CUSTOMER"] = "customer";
    AutocompleteType["ADDRESS"] = "address";
})(exports.AutocompleteType || (exports.AutocompleteType = {}));
exports.AutocompleteOnLoadHeading = void 0;
(function (AutocompleteOnLoadHeading) {
    AutocompleteOnLoadHeading["CUSTOMER"] = "Type a Customer Name...";
    AutocompleteOnLoadHeading["ADDRESS"] = "Type a Location Name or an Address...";
})(exports.AutocompleteOnLoadHeading || (exports.AutocompleteOnLoadHeading = {}));

const NerdDate = ({ label = "", placeholder = "", helperText = " ", required = false, variant = "standard", onChange, value, }) => {
    return (jsxRuntime.jsx(LocalizationProvider.LocalizationProvider, Object.assign({ dateAdapter: AdapterMoment.AdapterMoment }, { children: jsxRuntime.jsx(MobileDatePicker.MobileDatePicker, { label: label, value: value, onChange: onChange, minDate: moment__default["default"](), renderInput: (params) => (jsxRuntime.jsx(TextField__default["default"], Object.assign({}, params, { variant: variant, placeholder: placeholder, InputLabelProps: {
                    shrink: true,
                }, helperText: required ? exports.InputAux.REQUIRED : helperText, required: required, fullWidth: true }))) }) })));
};

var css_248z$2 = ".Nerd-Text--required .MuiInputLabel-root {\n  display: flex;\n}";
styleInject(css_248z$2);

const NerdText = ({ label = "", placeholder = "", id, variant = "standard", required, disabled, error, helperText, value, onChange, onKeyPress, onBlur, onClick, }) => {
    return (jsxRuntime.jsx(TextField__default["default"], { error: error, "aria-haspopup": "true", disabled: disabled, id: id, label: label, placeholder: placeholder, fullWidth: true, helperText: required ? exports.InputAux.REQUIRED : helperText, required: required, value: value, onChange: onChange, onKeyPress: onKeyPress, onBlur: onBlur, onClick: onClick, InputLabelProps: {
            shrink: true,
        }, variant: variant, className: required ? "Nerd-Text--required" : "", sx: {
            "& .MuiInputLabel-root": {
                display: "flex",
            },
        } }));
};

const NerdPassword = ({ label = "", placeholder = "", id, variant = "standard", required = false, disabled, error, helperText, value, onChange, }) => {
    return (jsxRuntime.jsx(TextField__default["default"], { required: required, error: error, "aria-haspopup": "true", disabled: disabled, id: id, label: label, placeholder: placeholder, fullWidth: true, helperText: required ? required : helperText, value: value, onChange: onChange, InputLabelProps: {
            shrink: true,
        }, variant: variant, type: "password" }));
};

const NerdInput = (_a) => {
    var { type = "text" } = _a, props = __rest(_a, ["type"]);
    const [close, setClose] = React.useState(false);
    const { icon, spacing = 1, disabled, fullWidth, alignItems = "center", inputSize = 6, onChange, } = props;
    const sizeWithIcons = fullWidth ? 11 : inputSize;
    const customInputSize = fullWidth && !icon ? 12 : sizeWithIcons;
    return (jsxRuntime.jsx(ConditionalWrapper, Object.assign({ condition: icon !== undefined, wrapper: (childrenContent) => (jsxRuntime.jsx(Grid__default["default"], Object.assign({ container: true, spacing: spacing, alignItems: alignItems }, { children: childrenContent }))) }, { children: jsxRuntime.jsxs(React__default["default"].Fragment, { children: [icon && jsxRuntime.jsx(Grid__default["default"], Object.assign({ item: true }, { children: icon })), jsxRuntime.jsx(Grid__default["default"], Object.assign({ item: true, sm: customInputSize, xs: icon ? 9 : 12 }, { children: renderNerdInputByType({ type, props, close, setClose, onChange }) })), icon && (jsxRuntime.jsx(Grid__default["default"], Object.assign({ item: true }, { children: jsxRuntime.jsx(IconButton__default["default"], Object.assign({ disabled: disabled, size: "small", onClick: () => setClose(true) }, { children: jsxRuntime.jsx(CloseIcon__default["default"], {}) })) })))] }) })));
};
/**
 * @param auxProps
 * @param auxProps.type
 * @param auxProps.props
 * @param auxProps.close
 * @param auxProps.setClose
 * @param auxProps.onChange
 */
function renderNerdInputByType(auxProps) {
    const { type, props } = auxProps;
    switch (type) {
        case "date":
            return jsxRuntime.jsx(NerdDate, Object.assign({}, props));
        case "text":
            return jsxRuntime.jsx(NerdText, Object.assign({}, props));
        case "password":
            return jsxRuntime.jsx(NerdPassword, Object.assign({}, props));
        default:
            return jsxRuntime.jsx(NerdText, Object.assign({}, props));
    }
}

var css_248z$1 = ".autocompleteSmall {\n  min-width: 40vw;\n  transform: translate(-9vw, -1vh);\n}\n\n@media only screen and (max-width: 600px) {\n  .autocompleteSmall {\n    min-width: 60vw;\n    transform: translate(0vw, 3vh);\n  }\n}";
styleInject(css_248z$1);

/**
 * Function to that create a unique id
 *
 * @returns {string} - A unique id as string
 */
function uid() {
    const head = Date.now().toString(36);
    const tail = Math.random().toString(36).slice(2);
    return `${head}${tail}`;
}
/**
 * @param value
 */
function setAxeValue(value) {
    if (!value) {
        return "-";
    }
    return value.toLowerCase().replace(/\s/g, "-");
}

/**
 * @param { React.HTMLAttributes<HTMLElement> } paperProps - Autocomplete props onLoad
 * @returns { React.ReactElement } - Render react Autocomplete component onLoad
 */
function PaperComponentOnLoad(paperProps) {
    const { className, inputValue, loading, autocompleteType } = paperProps, other = __rest(paperProps, ["className", "inputValue", "loading", "autocompleteType"]);
    return (jsxRuntime.jsx(Paper__default["default"], Object.assign({}, other, { className: className ? "autocompleteSmall" : "" }, { children: jsxRuntime.jsx(ClickAwayListener__default["default"], Object.assign({ onClickAway: () => console.log("onClick") }, { children: jsxRuntime.jsx(React__default["default"].Fragment, { children: inputValue && loading ? (jsxRuntime.jsxs(WrapperCustomerOnload, { children: [jsxRuntime.jsx(CircularProgress__default["default"], { color: "primary", size: 40 }), jsxRuntime.jsx(NerdHeading, { text: "loading", variant: "h6" })] })) : (contentOnLoad(autocompleteType, inputValue, loading)) }) })) })));
}
const CustomerOnload = () => {
    return (jsxRuntime.jsxs(WrapperCustomerOnload, { children: [jsxRuntime.jsx(PersonSearchIcon__default["default"], { fontSize: "large" }), jsxRuntime.jsx(NerdHeading, { text: exports.AutocompleteOnLoadHeading.CUSTOMER, variant: "h6" })] }));
};
const AdrressOnload = () => {
    return (jsxRuntime.jsxs(React__default["default"].Fragment, { children: [jsxRuntime.jsxs(WrapperCustomerOnload, { children: [jsxRuntime.jsx(MapTwoToneIcon__default["default"], { fontSize: "large" }), jsxRuntime.jsx(NerdHeading, { text: exports.AutocompleteOnLoadHeading.ADDRESS, variant: "h6" })] }), jsxRuntime.jsx(material.Divider, {}), jsxRuntime.jsx(Grid__default["default"], Object.assign({ container: true, alignItems: "center", justifyContent: "center" }, { children: jsxRuntime.jsx(Grid__default["default"], Object.assign({ item: true, py: 1 }, { children: jsxRuntime.jsxs(material.Typography, Object.assign({ display: "block", variant: "caption", color: "textSecondary" }, { children: ["Powered by ", jsxRuntime.jsx("b", { children: "Google" }), " and ", jsxRuntime.jsx("b", { children: "Archer" })] })) })) }))] }));
};
const WrapperCustomerOnload = (props) => {
    return (jsxRuntime.jsx(material.Stack, Object.assign({ direction: "column", justifyContent: "center", alignItems: "center", spacing: 2, py: 7 }, { children: props.children })));
};
/**
 * @param {any} args - content onLoad args
 * @returns {void}
 */
function contentOnLoad(...args) {
    return args.map((arg, i) => {
        if (i === 0 && typeof arg === "string" && arg !== "") {
            switch (arg) {
                case exports.AutocompleteType.CUSTOMER:
                    return jsxRuntime.jsx(CustomerOnload, {}, uid());
                case exports.AutocompleteType.ADDRESS:
                    return jsxRuntime.jsx(AdrressOnload, {}, uid());
            }
        }
        return jsxRuntime.jsx(React__default["default"].Fragment, {}, uid());
    });
}

const RenderTemplate = ({ props, option, autocompleteType, className = "", optionsArray = [], onClick, }) => {
    const ListFoot = () => {
        return optionsArray[optionsArray.length - 1] === option ? (jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [jsxRuntime.jsx(Divider__default["default"], {}), jsxRuntime.jsx(Grid__default["default"], Object.assign({ container: true, alignItems: "center", justifyContent: "center" }, { children: jsxRuntime.jsx(Grid__default["default"], Object.assign({ item: true, py: 1 }, { children: jsxRuntime.jsxs(Typography__default["default"], Object.assign({ display: "block", variant: "caption", color: "textSecondary" }, { children: ["Powered by ", jsxRuntime.jsx("b", { children: "Google" }), " and ", jsxRuntime.jsx("b", { children: "Archer" })] })) })) }))] })) : null;
    };
    return (jsxRuntime.jsxs(React__default["default"].Fragment, { children: [jsxRuntime.jsx(Box__default["default"], Object.assign({ component: "li", sx: {
                    backgroundColor: "transparent",
                    svg: { flexShrink: 0, color: "white" },
                    cursor: "pointer",
                    "&:hover": {
                        backgroundColor: "rgba(0, 0, 0, 0.08)",
                    },
                } }, props, { className: className, onClick: onClick }, { children: jsxRuntime.jsx(CardHeader__default["default"], { avatar: jsxRuntime.jsx(Avatar__default["default"], Object.assign({ sx: {
                            bgcolor: setTemplateIconColorByType(autocompleteType, option),
                        }, "aria-label": autocompleteType }, { children: setTemplateIconByType(autocompleteType) })), title: setTemplateTitle(autocompleteType, option), titleTypographyProps: { fontWeight: "500", variant: "body1" }, subheader: setTemplateContentByType(autocompleteType, option), sx: {
                        py: 1,
                        px: 1,
                    } }) }), toolkit.nanoid()), jsxRuntime.jsx(ListFoot, {})] }));
};
/**
 *
 * @param type
 */
function setTemplateIconByType(type) {
    switch (type) {
        case exports.AutocompleteType.CUSTOMER:
            return jsxRuntime.jsx(CorporateFareIcon__default["default"], { fontSize: "medium" });
        case exports.AutocompleteType.ADDRESS:
            return jsxRuntime.jsx(LocationOnTwoToneIcon__default["default"], { fontSize: "medium" });
        default:
            return jsxRuntime.jsx(CorporateFareIcon__default["default"], { fontSize: "medium" });
    }
}
/**
 *
 * @param type
 * @param option
 */
function setTemplateIconColorByType(type, option) {
    switch (type) {
        case exports.AutocompleteType.CUSTOMER:
            return colors.blue[500];
        case exports.AutocompleteType.ADDRESS:
            if (option.name) {
                return colors.blue[500];
            }
            return colors.grey[500];
        default:
            return colors.blue[500];
    }
}
/**
 *
 * @param type
 * @param option
 */
function setTemplateContentByType(type, option) {
    const auxContentCredit = option.credit_on_hold ? " - ( Credit Hold )" : "";
    const auxContentInactivity = option.inactivity_hold
        ? " - ( Inactivity Hold )"
        : "";
    switch (type) {
        case exports.AutocompleteType.CUSTOMER:
            return `${option.line1} ${option.state} ${option.zip} ${auxContentCredit} ${auxContentInactivity}`;
        case exports.AutocompleteType.ADDRESS:
            if (option.structured_formatting) {
                return `${option.structured_formatting.secondary_text}`;
            }
            return option.name;
        default:
            return "";
    }
}
/**
 *
 * @param type
 * @param option
 */
function setTemplateTitle(type, option) {
    switch (type) {
        case exports.AutocompleteType.CUSTOMER:
            return `${option.name}`;
        case exports.AutocompleteType.ADDRESS:
            if (option.structured_formatting) {
                return `${option.structured_formatting.main_text}`;
            }
            return option.name;
        default:
            return "";
    }
}

const NerdAutoComplete = ({ itemID, value, fullWidth, onChange, onInputChange, inputValue, label, placeholder, options = [], variant = "standard", required = false, helperText, loading, autocompleteType = exports.AutocompleteType.CUSTOMER, icon, spacing = 1, alignItems = "center", disabled = false, 
//inputSize = 6,
autoCompleteOptionLabel = "", className, isEditable = false, }) => {
    const [open, setOpen] = React.useState(false);
    // const sizeWithIcons = fullWidth ? 11 : inputSize;
    //const customInputSize = fullWidth && !icon ? 12 : sizeWithIcons;
    return (jsxRuntime.jsx(ConditionalWrapper, Object.assign({ condition: icon !== undefined, wrapper: (childrenContent) => (jsxRuntime.jsx(Grid__default["default"], Object.assign({ container: true, spacing: spacing, alignItems: alignItems }, { children: childrenContent }))) }, { children: jsxRuntime.jsxs(React__default["default"].Fragment, { children: [icon && jsxRuntime.jsx(Grid__default["default"], Object.assign({ item: true }, { children: icon })), jsxRuntime.jsx(Grid__default["default"], Object.assign({ item: true, sm: true }, { children: jsxRuntime.jsx(Autocomplete__default["default"], { id: itemID, open: open, value: value, fullWidth: fullWidth, onOpen: () => setOpen(true), onClose: () => setOpen(false), onChange: onChange, onInputChange: onInputChange, inputValue: inputValue, options: options, clearIcon: null, getOptionLabel: (option) => getOptionLabel(option, autoCompleteOptionLabel), onKeyDown: (event) => {
                            if (event.key === "Enter") {
                                // Prevent's default 'Enter' behavior.
                                event.preventDefault();
                                // handler code
                            }
                        }, renderInput: (params) => (jsxRuntime.jsx(TextField__default["default"], Object.assign({}, params, { label: label, variant: variant, placeholder: placeholder, InputLabelProps: {
                                shrink: true,
                            }, InputProps: Object.assign(Object.assign({}, params.InputProps), { endAdornment: null }), helperText: renderHelperText(required, helperText), required: required, fullWidth: true }))), renderOption: (props, option) => {
                            return (jsxRuntime.jsx(RenderTemplate, Object.assign({}, props, { option: option, autocompleteType: autocompleteType, optionsArray: options })));
                        }, PaperComponent: (props) => {
                            if (!inputValue || loading) {
                                return (React.createElement(PaperComponentOnLoad, Object.assign({}, { props, inputValue, autocompleteType, loading }, { key: toolkit.nanoid(), className: className ? "autocompleteSmall" : "" })));
                            }
                            return (React.createElement(Paper__default["default"], Object.assign({}, props, { key: toolkit.nanoid(), className: className ? "autocompleteSmall" : "" }), props.children));
                        } }) })), icon && (jsxRuntime.jsxs(Grid__default["default"], Object.assign({ item: true, flexDirection: "column", display: "flex" }, { children: [isEditable && (jsxRuntime.jsx(IconButton__default["default"], Object.assign({ disabled: disabled, size: "small", onClick: (event) => {
                                setOpen(false);
                                onChange(event, "");
                                onInputChange(event, "");
                            } }, { children: jsxRuntime.jsx(EditIcon__default["default"], { fontSize: "small" }) }))), jsxRuntime.jsx(IconButton__default["default"], Object.assign({ disabled: disabled, size: "small", onClick: (event) => {
                                setOpen(false);
                                onChange(event, "");
                                onInputChange(event, "");
                            } }, { children: jsxRuntime.jsx(CloseIcon__default["default"], { fontSize: "small" }) }))] })))] }) })));
};
/**
 *
 * @param required
 * @param helperText
 */
function renderHelperText(required, helperText) {
    if (!helperText) {
        return "";
    }
    return required ? exports.InputAux.REQUIRED : helperText;
}
/**
 *
 * @param option
 * @param autoCompleteOptionLabel
 */
function getOptionLabel(option, autoCompleteOptionLabel) {
    if (typeof option === "string") {
        return option;
    }
    if (typeof option === "object" && Object.keys(option).length > 0) {
        return option[autoCompleteOptionLabel];
    }
    return "";
}

const CustomArrow = ({ onPageChange, page, disabledNext, children, }) => {
    const disablePrev = page === 1;
    const { t } = reactI18next.useTranslation("components", { i18n: i18n });
    return (jsxRuntime.jsxs(material.Box, { children: [jsxRuntime.jsx(material.Tooltip, Object.assign({ title: `${t("nerdPagination.first")} ${t("nerdPagination.page")}`, placement: "bottom", enterDelay: 300 }, { children: jsxRuntime.jsx("span", { children: jsxRuntime.jsx(material.IconButton, Object.assign({ onClick: (e) => onPageChange(e, 1), disabled: disablePrev, "aria-label": `${t("nerdPagination.first")} ${t("nerdPagination.page")}` }, { children: jsxRuntime.jsx(iconsMaterial.FirstPage, {}) })) }) })), jsxRuntime.jsx(material.Tooltip, Object.assign({ title: `${t("nerdPagination.prev")} ${t("nerdPagination.page")}`, placement: "bottom", enterDelay: 300 }, { children: jsxRuntime.jsx("span", { children: jsxRuntime.jsx(material.IconButton, Object.assign({ onClick: (e) => onPageChange(e, page - 1), disabled: disablePrev, "aria-label": `${t("nerdPagination.previous")} ${t("nerdPagination.page")}` }, { children: jsxRuntime.jsx(iconsMaterial.KeyboardArrowLeft, {}) })) }) })), children, jsxRuntime.jsx(material.Tooltip, Object.assign({ title: `${t("nerdPagination.next")} ${t("nerdPagination.page")}`, placement: "bottom", enterDelay: 300 }, { children: jsxRuntime.jsx("span", { children: jsxRuntime.jsx(material.IconButton, Object.assign({ onClick: (e) => {
                            onPageChange(e, page + 1);
                        }, "aria-label": `${t("nerdPagination.next")} ${t("nerdPagination.page")}`, disabled: disabledNext }, { children: jsxRuntime.jsx(iconsMaterial.KeyboardArrowRight, {}) })) }) }))] }));
};

var css_248z = "@charset \"UTF-8\";\n.nerdUI {\n  /* Other screens */\n  /* mobile devices*/\n}\n.nerdUI--pagination .MuiToolbar-root .MuiTablePagination-spacer {\n  display: none;\n}\n.nerdUI--pagination .MuiToolbar-root .paginationContainer {\n  flex-wrap: nowrap;\n}\n.nerdUI--pagination-sm .MuiToolbar-root {\n  flex-wrap: wrap;\n  justify-content: center;\n}\n.nerdUI--pagination-sm .MuiToolbar-root .paginationContainer {\n  justify-content: center;\n}\n.nerdUI--pagination-pages .MuiPagination-roo  {\n  display: inline;\n}\n.nerdUI--pagination-pages .MuiPagination-roo  .MuiPagination-ul {\n  display: inline;\n}\n.nerdUI--pagination-pages .MuiPagination-roo  .MuiPagination-ul li {\n  display: inline;\n}";
styleInject(css_248z);

const PageActions = (props) => {
    const { page, onPageChange, selectPages, disabledNext } = props;
    const pagesStored = [
        ...Array.from(new Set(selectPages.sort((a, b) => a - b))),
    ];
    const theme = material.useTheme();
    const matches = material.useMediaQuery(theme.breakpoints.down("sm"));
    return (jsxRuntime.jsx(Grid__default["default"], Object.assign({ container: true, alignItems: "center", className: "paginationContainer", sx: { marginLeft: "1rem" } }, { children: jsxRuntime.jsx(Grid__default["default"], Object.assign({ item: true }, { children: jsxRuntime.jsx(CustomArrow, Object.assign({}, {
                onPageChange,
                page,
                disabledNext,
                pagesStored,
            }, { children: jsxRuntime.jsx(Pagination__default["default"], { count: pagesStored[pagesStored.length - 1], page: page, siblingCount: matches ? 0 : 1, size: matches ? "small" : "medium", hideNextButton: true, hidePrevButton: true, sx: {
                        display: "inline",
                        "&.MuiPagination-root *": {
                            display: "inline",
                        },
                    }, onChange: (event, page) => {
                        onPageChange(event, page);
                    } }) })) })) })));
};

exports.nerdPaginationAuxContent = void 0;
(function (nerdPaginationAuxContent) {
    nerdPaginationAuxContent["Rows"] = "Rows";
})(exports.nerdPaginationAuxContent || (exports.nerdPaginationAuxContent = {}));

const NerdPagination = ({ page, rowsPerPage, rowPageOptions, selectPages, disabledNext, handleChangePage, handleChangeRowsPerPage, }) => {
    const theme = styles$1.useTheme();
    const matches = useMediaQuery__default["default"](theme.breakpoints.down("sm"));
    return (jsxRuntime.jsx(TablePagination__default["default"], { component: "div", count: -1, page: page, onPageChange: handleChangePage, rowsPerPage: rowsPerPage, rowsPerPageOptions: rowPageOptions, onRowsPerPageChange: handleChangeRowsPerPage, ActionsComponent: (props) => (jsxRuntime.jsx(PageActions, Object.assign({ selectPages: selectPages, disabledNext: disabledNext }, props))), labelDisplayedRows: () => {
            return "";
        }, labelRowsPerPage: exports.nerdPaginationAuxContent.Rows, getItemAriaLabel: (type) => `Go to ${type} page`, backIconButtonProps: {
            "aria-label": "Previous Page",
        }, nextIconButtonProps: {
            "aria-label": "Next Page",
        }, className: `nerdUI--pagination ${matches ? "nerdUI--pagination-sm" : ""}` }));
};

const notificationInitialState = {
    notification: {
        uuid: "",
    },
};
const notificationSlice = toolkit.createSlice({
    name: "notification",
    initialState: notificationInitialState,
    reducers: {
        showNotification: (_state, action) => {
            return Object.assign({}, action.payload);
        },
        clearNotification: () => {
            return notificationInitialState;
        },
    },
});
const { showNotification, clearNotification } = notificationSlice.actions;
const notificationReducer = notificationSlice.reducer;

/**
 * NerdClickToCopy component
 *
 * @param {propsType} props Component props
 * @returns {ReactElement} NerdClickToCopy
 */
function NerdClickToCopy(props) {
    const { children, typographyProps, hoverBorderColor, hoverBackgroundColor } = props;
    const CLICK_TO_COPY = "Click to copy";
    const COPIED = "Copied !";
    const [tooltipText, setTooltipText] = React.useState(CLICK_TO_COPY);
    const sx = Object.assign(Object.assign({}, typographyProps === null || typographyProps === void 0 ? void 0 : typographyProps.sx), { margin: "1px 4px 1px 4px", padding: 0, ":hover": {
            backgroundColor: hoverBackgroundColor || "rgba(0, 153, 255, 0.28)",
            border: `1px ${hoverBorderColor || "rgba(0, 153, 255, 1)"} solid`,
            borderRadius: "5px",
            padding: "0px 3px 0px 3px",
            margin: 0,
        } });
    /**
     * Copy to clipboard
     *
     * @param {MouseEvent<HTMLSpanElement, MouseEvent>} e Click Event
     * @returns {Promise<void>}
     */
    function copy(e) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!navigator.clipboard)
                return;
            const value = e.currentTarget.textContent;
            if (value !== null) {
                yield navigator.clipboard.writeText(value);
                setTooltipText(COPIED);
            }
        });
    }
    return (jsxRuntime.jsx(Tooltip__default["default"], Object.assign({ title: tooltipText, enterTouchDelay: 0 }, { children: jsxRuntime.jsx(Typography__default["default"], Object.assign({}, typographyProps, { onClick: (e) => {
                var _a;
                (_a = typographyProps === null || typographyProps === void 0 ? void 0 : typographyProps.onClick) === null || _a === void 0 ? void 0 : _a.call(typographyProps, e);
                copy(e);
            }, onMouseOver: () => setTooltipText(CLICK_TO_COPY), sx: sx }, { children: children })) })));
}

/**
 *
 * @param {NerdAppsMenuProps} props Component props
 * @returns {ReactElement} NerdAppsMenu
 */
function NerdAppsMenu(props) {
    const { apps, homePath, appIconHeight, appIconWidth } = props;
    const { t } = reactI18next.useTranslation("common", { i18n: i18n });
    return (jsxRuntime.jsxs(material.Grid, Object.assign({ container: true, padding: "10px" }, { children: [apps.map((app, i) => {
                var _a;
                return (jsxRuntime.jsx(material.Grid, Object.assign({ item: true, xs: 4, sm: 3 }, { children: jsxRuntime.jsx(AppIcon, { iconHeigt: appIconHeight, iconWidth: appIconWidth, app: app }) }), (_a = app.name) === null || _a === void 0 ? void 0 : _a.concat(i.toString())));
            }), jsxRuntime.jsx(material.Grid, Object.assign({ item: true, xs: 12, mt: 2, textAlign: "center" }, { children: homePath && (jsxRuntime.jsx(material.Button, Object.assign({ href: homePath, variant: "outlined", startIcon: jsxRuntime.jsx(iconsMaterial.Home, {}) }, { children: t("components:nerdAppsMenu.home") }))) }))] })));
}
/**
 *
 * @param {object} props Component props
 * @param {App} props.app App to render
 * @param {number | undefined} props.iconWidth App icon width
 * @param {number | undefined} props.iconHeigt App to render
 * @returns {ReactElement} AppIcon
 */
function AppIcon(props) {
    const { app, iconHeigt, iconWidth } = props;
    const _iconHeigt = iconHeigt || 40;
    const _iconWidth = iconWidth || 40;
    const [hover, setHover] = React.useState(false);
    const transition = "ease-in";
    const { t } = reactI18next.useTranslation("components", { i18n: i18n });
    return (jsxRuntime.jsxs(material.Box, Object.assign({ sx: {
            display: "flex",
            flexDirection: "column",
            alignContent: "center",
            alignItems: "center",
            animationDelay: `-${Math.random()}s`,
            animationDuration: `.${Math.floor(Math.random() * 11) + 20}s`,
        }, onMouseEnter: () => setHover(true), onMouseLeave: () => setHover(false) }, { children: [app.url ? (jsxRuntime.jsx("a", Object.assign({ href: `https://${app.url}`, style: {
                    textDecoration: "none",
                } }, { children: app.icon ? (jsxRuntime.jsx("img", { src: app.icon, alt: t("nerdAppsMenu.app_icon_alt"), width: _iconWidth, height: _iconHeigt, style: {
                        borderRadius: "20%",
                        boxShadow: hover
                            ? "0 5px 18px 0 rgba(0,0,0,.3)"
                            : "0 5px 28px 0 rgba(0,0,0,.1)",
                        transition: `box-shadow .2s ${transition}`,
                    } })) : (jsxRuntime.jsx(material.Box, Object.assign({ sx: {
                        backgroundColor: app.color,
                        marginBottom: "5px",
                        width: `${_iconWidth}px`,
                        height: `${_iconHeigt}px`,
                        textAlign: "center",
                        border: `solid ${40 * 0.05}px ${app.color}`,
                        background: "#424242",
                        color: app.color,
                        fontFamily: "Futura",
                        fontSize: _iconHeigt * 0.5,
                        borderTopRightRadius: 40 * 0.5,
                        borderBottomLeftRadius: 40 * 0.5,
                        boxShadow: hover
                            ? "0 5px 18px 0 rgba(0,0,0,.3)"
                            : "0 5px 28px 0 rgba(0,0,0,.1)",
                        transition: `box-shadow .2s ${transition}`,
                    } }, { children: jsxRuntime.jsx(material.Grid, Object.assign({ container: true, justifyContent: "center", alignItems: "center", style: { height: 35 } }, { children: app.name && jsxRuntime.jsx(material.Grid, Object.assign({ item: true }, { children: `${app.name[0]}${app.name[1]}` })) })) }))) }))) : null, jsxRuntime.jsx(material.Typography, Object.assign({ fontWeight: "300", fontSize: "14px", textAlign: "center" }, { children: app.name }))] })));
}

/**
 * DataGrid boolean filter input.
 *
 * @param {GridFilterInputValueProps} props Component props
 * @returns {React.ReactElement} CheckBox input for boolean type filter.
 */
function BoolOperatorInput(props) {
    const { item, applyValue, focusElementRef } = props;
    const ref = React__default["default"].useRef(null);
    React__default["default"].useImperativeHandle(focusElementRef, () => ({
        focus: () => {
            var _a, _b;
            (_b = (_a = ref === null || ref === void 0 ? void 0 : ref.current) === null || _a === void 0 ? void 0 : _a.querySelector(`input[value="${item.value || ""}"]`)) === null || _b === void 0 ? void 0 : _b.focus();
        },
    }));
    const handleFilterChange = (event) => {
        applyValue(Object.assign(Object.assign({}, item), { value: event.target.checked }));
    };
    return (jsxRuntime.jsx(material.FormControlLabel, { sx: { paddingLeft: "20px", paddingTop: "10px" }, control: jsxRuntime.jsx(material.Switch, { checked: item.value || false, onChange: (e) => handleFilterChange(e), inputProps: { "aria-label": "controlled" } }), label: item.columnField.charAt(0).toUpperCase() +
            item.columnField.substring(1, item.columnField.length) }));
}

const OPERATORS = {
    eq: {
        label: "Equal",
        value: "eq",
    },
    neq: {
        label: "Not Equal",
        value: "neq",
    },
    gt: {
        label: "Greater Than",
        value: "gt",
    },
    lt: {
        label: "Less Than",
        value: "lt",
    },
    gte: {
        label: "Greater or Equal Than",
        value: "gte",
    },
    lte: {
        label: "Less or Equal Than",
        value: "lte",
    },
    like: {
        label: "Like",
        value: "like",
    },
};
/**
 * Return DataGrid filter operators for a given column type.
 *
 * @param {string | undefined} type Type of the column.
 * @returns {Array<GridFilterOperator>} Return filter operators.
 */
function operatorsByType(type) {
    let input;
    let inputProps = {};
    let operatorsKey = [];
    switch (type) {
        case "date":
            input = xDataGridPro.GridFilterInputDate;
            inputProps = { type: "date" };
            operatorsKey = ["eq", "neq", "gt", "lt", "gte", "lte"];
            break;
        case "dateTime":
            input = xDataGridPro.GridFilterInputDate;
            inputProps = { type: "datetime-local" };
            operatorsKey = ["eq", "neq", "gt", "lt", "gte", "lte"];
            break;
        case "dateLike":
            input = xDataGridPro.GridFilterInputDate;
            inputProps = { type: "date" };
            operatorsKey = ["gt", "lt", "gte", "like"];
            break;
        case "boolean":
            input = BoolOperatorInput;
            operatorsKey = ["eq"];
            break;
        case "number":
            input = xDataGridPro.GridFilterInputValue;
            inputProps = { type: "number" };
            operatorsKey = ["eq", "neq", "gt", "lt", "gte", "lte", "like"];
            break;
        case "singleSelect":
            input = xDataGridPro.GridFilterInputSingleSelect;
            operatorsKey = ["eq", "neq"];
            break;
        case "actions":
            input = undefined;
            break;
        case "string":
            input = xDataGridPro.GridFilterInputValue;
            operatorsKey = ["eq", "neq", "like"];
            break;
        default:
            input = xDataGridPro.GridFilterInputValue;
            operatorsKey = ["eq", "neq", "gt", "lt", "gte", "lte", "like"];
            break;
    }
    return createOperators(operatorsKey, input, inputProps);
}
/**
 *
 * @param {string[]} operatorsKey Operators key
 * @param {JSXElementConstructor<GridFilterInputValueProps>} input Grid Filter Input
 * @param {Record<string, unknown>} inputProps Grid Filter Input Props
 * @returns {GridFilterOperator<any, any, any>[]} Grid Filter Operators
 */
function createOperators(operatorsKey, input, inputProps) {
    const operators = [];
    operatorsKey.forEach((key) => {
        const val = OPERATORS[key];
        operators.push({
            label: val.label,
            value: val.value,
            getApplyFilterFn: () => {
                //ServerSide filter, so we don't need filter function here.
                return () => {
                    return true;
                };
            },
            InputComponent: input,
            InputComponentProps: inputProps,
        });
    });
    return operators;
}

/**
 * NerdDataGrid component.
 *
 * @param {propsType} props NerdDataGrid props.
 * @returns {ReactElement} DataGrid wrapper with server-side filters.
 */
function NerdDataGrid(props) {
    const { columnsVisibility, columns, queryParams, setQueryparams, getRows, culumnsMatchingFilterName, hidePagination, hideFilters, defaultSelectRowID, createNewButton, requestPending, initialRowsPerPage, editable, updateRow, deleteRow, deleteSelectedRows, } = props;
    const rows = props.rows;
    const rowPageOptions = [10, 50, 100];
    let limit;
    let offset;
    let filters;
    if (queryParams) {
        limit = queryParams["limit"];
        offset = queryParams["offset"];
        filters = queryParams["filters"];
    }
    const [rowsPerPage, setRowsPerPage] = React.useState(initialRowsPerPage ? initialRowsPerPage : 10);
    const { t } = reactI18next.useTranslation("common", { i18n: i18n });
    const [page, setPage] = React.useState(1);
    const [selectPages, setSelectPages] = React.useState([0]);
    const [disabledNext, setDisabledNext] = React.useState(false);
    const [rowCount, setRowCount] = React.useState(undefined);
    const [rowCountState, setRowCountState] = React.useState(rowCount || 0);
    const [queryObject, setQueryObject] = React.useState(culumnsMatchingFilterName
        ? {
            filters: filters ? filters : "",
            limit: Number(limit) ? Number(limit) : rowsPerPage,
            offset: Number(offset) ? Number(offset) : 0,
        }
        : {
            limit: Number(limit) ? Number(limit) : rowsPerPage,
            offset: Number(offset) ? Number(offset) : 0,
        });
    const [filterModel, setFilterModel] = React.useState({
        items: [],
        linkOperator: xDataGridPro.GridLinkOperator.And,
    });
    const [selectionModel, setSelectionModel] = React.useState(defaultSelectRowID &&
        rows.filter((row) => row["id"] === defaultSelectRowID).length > 0
        ? [defaultSelectRowID]
        : []);
    const prevSelectionModel = React.useRef(defaultSelectRowID ? [defaultSelectRowID] : []);
    React.useEffect(() => {
        if (getRows) {
            setRowCount(undefined);
            getRows(queryObject);
        }
    }, [queryObject]);
    // Check if API call ends and close loading
    React.useEffect(() => {
        setRowCount(rows.length);
        //restore selection model after page change
        setSelectionModel(prevSelectionModel.current);
        setCustomPagination();
    }, [rows]);
    React.useEffect(() => {
        try {
            if (culumnsMatchingFilterName &&
                filters &&
                culumnsMatchingFilterName.size > 0) {
                const filtersObject = JSON.parse(filters);
                const filterModelTmp = {
                    items: [],
                    linkOperator: xDataGridPro.GridLinkOperator.And,
                };
                Array.isArray(filtersObject) &&
                    filtersObject.forEach((filter, i) => {
                        let columnField = "";
                        for (const [key, value] of culumnsMatchingFilterName.entries()) {
                            if (value === filter.name)
                                columnField = key;
                        }
                        filterModelTmp.items.push({
                            id: i + 1,
                            columnField,
                            value: filter.value,
                            operatorValue: filter.comparison,
                        });
                    });
                setFilterModel(filterModelTmp);
            }
        }
        catch (error) {
            return;
        }
    }, [culumnsMatchingFilterName]);
    // Set URL query
    React.useEffect(() => {
        if (setQueryparams) {
            if (Number(offset) % Number(limit) !== 0 ||
                !rowPageOptions.includes(Number(limit))) {
                const limit = initialRowsPerPage || 10;
                setQueryObject(Object.assign(Object.assign({}, queryObject), { limit, offset: 0 }));
                setPage(1);
                setRowsPerPage(limit);
            }
            else if (Number(limit) === queryObject.limit) {
                setPage(Number(offset) / Number(limit) + 1);
                setRowsPerPage(Number(limit));
            }
            setQueryparams(queryObject);
        }
    }, [offset, limit, queryObject]);
    React.useEffect(() => {
        setRowCountState((prevRowCountState) => rowCount !== undefined ? rowCount : prevRowCountState);
    }, [rowCount, setRowCountState]);
    /**
     * Custom MUI Grid Toolbar
     *
     * @returns {React.ReactElement} Mui Grid Toolbar
     */
    function CustomToolbar() {
        return (jsxRuntime.jsxs(xDataGridPro.GridToolbarContainer, { children: [!hideFilters && jsxRuntime.jsx(xDataGridPro.GridToolbarFilterButton, {}), props.apiExportEndpoint && (jsxRuntime.jsx(material.Button, Object.assign({ sx: { fontSize: "0.8rem" }, variant: "text", startIcon: jsxRuntime.jsx(iconsMaterial.SaveAlt, {}), onClick: () => {
                        const a = encodeURI(`${props.apiExportEndpoint}${"filters" in queryObject
                            ? `?filters=${queryObject.filters}`
                            : ""}`);
                        window.open(a, "_blank", "noopener,noreferrer");
                    } }, { children: t("components:nerdDataGrid.export") }))), createNewButton, editable && (jsxRuntime.jsx(material.Tooltip, Object.assign({ title: t("components:nerdDataGrid.delete_rows") }, { children: jsxRuntime.jsx(material.IconButton, Object.assign({ color: "primary", onClick: () => {
                            const selectedRows = rows.filter((row) => selectionModel.find((id) => row.id === id));
                            deleteSelectedRows === null || deleteSelectedRows === void 0 ? void 0 : deleteSelectedRows(selectedRows.map((row) => {
                                return row.id;
                            }));
                        } }, { children: jsxRuntime.jsx(iconsMaterial.Delete, {}) })) })))] }));
    }
    const setCustomPagination = React.useCallback(() => {
        if (Number(offset) > 0 || Number(limit) > 0) {
            setSelectPages((prevState) => [
                ...Array.from(new Set(prevState)),
                ...Array(page)
                    .fill(0)
                    .map((_e, i) => i + 1),
            ]);
        }
    }, [limit, offset, page]);
    const onFilterChange = React.useCallback((newFilterModel) => {
        if (culumnsMatchingFilterName) {
            const filters = [];
            newFilterModel.items.forEach((item) => {
                const searchMetadataName = culumnsMatchingFilterName.get(item.columnField);
                if (item.operatorValue &&
                    item.value !== undefined &&
                    item.value !== "" &&
                    searchMetadataName) {
                    filters.push({
                        name: searchMetadataName,
                        comparison: item.operatorValue,
                        value: item.value,
                    });
                }
            });
            setPage(1); // Reset page to 1
            setSelectPages([0]); // Reset select pages
            setQueryObject({
                limit: queryObject.limit,
                offset: 0,
                filters: JSON.stringify(filters),
            });
            setFilterModel(newFilterModel);
        }
    }, [culumnsMatchingFilterName, queryObject.limit]);
    /**
     * Set new page value and change the query object
     *
     * @param {React.MouseEvent<HTMLButtonElement> | null} _event ChangePage
     * @param {number} newPage New page index
     */
    function handleChangePage(_event, newPage) {
        prevSelectionModel.current = selectionModel;
        setPage(newPage);
        if (newPage > 0) {
            setQueryObject(Object.assign(Object.assign({}, queryObject), { offset: (newPage - 1) * Number(limit) }));
        }
    }
    /**
     * @param {ChangeEvent<HTMLInputElement | HTMLTextAreaElement>} event - new rows page number selected
     */
    function handleChangeRowsPerPage(event) {
        const newPage = parseInt(event.target.value, 10);
        setPage(1); // Reset page to 1
        setSelectPages([0]); // Reset select pages
        // Set new query object
        setQueryObject((prevState) => (Object.assign(Object.assign({}, prevState), { limit: newPage, offset: 0 })));
    }
    /**
     *
     * @param {GridSelectionModel} ids Selected rows
     */
    function onSelectionModelChange(ids) {
        var _a, _b;
        const selectedIDs = new Set(ids);
        const selectedRows = rows.filter((row) => selectedIDs.has(row.id));
        const prevSelectedIDs = new Set(prevSelectionModel.current);
        //Don't call onSelect if page changed
        if (ids.length === 0) {
            if (rows.filter((row) => prevSelectedIDs.has(row.id)).length > 0) {
                (_a = props.onSelect) === null || _a === void 0 ? void 0 : _a.call(props, selectedRows);
            }
        }
        else {
            (_b = props.onSelect) === null || _b === void 0 ? void 0 : _b.call(props, selectedRows);
        }
        setSelectionModel(ids);
    }
    const handleDeleteClick = (id) => () => {
        deleteRow === null || deleteRow === void 0 ? void 0 : deleteRow(Number(id));
    };
    const processRowUpdate = (newRow) => {
        const updatedRow = Object.assign(Object.assign({}, newRow), { isNew: false });
        updateRow === null || updateRow === void 0 ? void 0 : updateRow(updatedRow);
        return updatedRow;
    };
    const columnsWithOperators = React.useMemo(() => {
        const columnsWithOperators = columns.map((col) => {
            return Object.assign(Object.assign({}, col), { filterOperators: operatorsByType(col.type) });
        });
        if (editable) {
            columnsWithOperators.push({
                field: "actions",
                type: "actions",
                headerName: "Actions",
                width: 100,
                cellClassName: "actions",
                getActions: ({ id }) => {
                    return [
                        jsxRuntime.jsx(xDataGridPro.GridActionsCellItem, { icon: jsxRuntime.jsx(iconsMaterial.Delete, {}), label: t("global.delete"), onClick: handleDeleteClick(id), onKeyUp: (event) => {
                                if (event.key === "Enter")
                                    ;
                            } }, "GridActionDelete"),
                    ];
                },
            });
        }
        return columnsWithOperators;
    }, [columns]);
    return (jsxRuntime.jsx(xDataGridPro.DataGridPro, Object.assign({}, props, { pageSize: rowsPerPage, rowsPerPageOptions: rowPageOptions, onStateChange: (state) => {
            const { pagination: { rowCount, pageSize }, } = state;
            setDisabledNext(rowCount < pageSize);
        }, pagination: true, paginationMode: "server", rowCount: rowCountState, hideFooterPagination: hidePagination, components: {
            Toolbar: CustomToolbar,
            Pagination: NerdPagination,
        }, componentsProps: {
            filterPanel: { linkOperators: ["and"] },
            pagination: {
                rowsPerPage,
                handleChangeRowsPerPage,
                rowPageOptions,
                handleChangePage,
                page,
                selectPages,
                disabledNext,
            },
        }, onSelectionModelChange: onSelectionModelChange, rows: rows, columns: columnsWithOperators, loading: requestPending, filterMode: "server", onFilterModelChange: onFilterChange, initialState: {
            columns: {
                columnVisibilityModel: columnsVisibility,
            },
        }, filterModel: filterModel, selectionModel: selectionModel }, (editable && {
        experimentalFeatures: {
            newEditingApi: true,
        },
        processRowUpdate: processRowUpdate,
        checkboxSelection: true,
        disableSelectionOnClick: true,
    }))));
}

const NerdConfirmContext = React.createContext({
    setOpen: () => {
        //Dummy function
        return;
    },
});

/**
 * NerdConfirmDialog
 *
 * @param {NerdConfirmDialogProps} props component props
 * @returns {ReactElement} NerdConfirmDialog
 */
function NerdConfirmDialog(props) {
    const { closeDialog, open, options } = props;
    const { content, title, cancelButtonProps, cancelButtonText, confirmButtonProps, confirmButtonText, contentProps, dialogProps, titleProps, actionsProps, onCancel, onConfirm, } = options;
    return (jsxRuntime.jsxs(material.Dialog, Object.assign({}, dialogProps, { open: open, onClose: closeDialog }, { children: [title && jsxRuntime.jsx(material.DialogTitle, Object.assign({}, titleProps, { children: title })), content && jsxRuntime.jsx(material.DialogContent, Object.assign({}, contentProps, { children: content })), jsxRuntime.jsxs(material.DialogActions, Object.assign({}, actionsProps, { children: [jsxRuntime.jsx(material.Button, Object.assign({}, cancelButtonProps, { onClick: () => {
                            onCancel === null || onCancel === void 0 ? void 0 : onCancel();
                            closeDialog();
                        } }, { children: cancelButtonText })), jsxRuntime.jsx(material.Button, Object.assign({}, confirmButtonProps, { onClick: () => {
                            onConfirm === null || onConfirm === void 0 ? void 0 : onConfirm();
                            closeDialog();
                        } }, { children: confirmButtonText }))] }))] })));
}

const NerdConfirmContextProvider = NerdConfirmContext.Provider;
/**
 * NerdConfirm
 *
 *
 * @param {PropsWithChildren<unknown>} props Component props
 * @returns {ReactElement} NerdConfirm
 */
function NerdConfirmProvider(props) {
    const { t } = reactI18next.useTranslation("common", { i18n: i18n });
    const defaultOptions = {
        title: t("components:nerdConfirm.are_you_sure"),
        cancelButtonText: t("global.cancel"),
        confirmButtonText: t("components:nerdConfirm.confirm"),
        content: t("components:nerdConfirm.ask_confirmation"),
        cancelButtonProps: {
            color: "error",
            variant: "contained",
        },
        confirmButtonProps: {
            color: "primary",
        },
    };
    const [open, setOpen] = React.useState(false);
    const [options, setOptions] = React.useState({});
    const _setOpen = (options = {}) => {
        setOptions(options);
        setOpen(true);
    };
    const closeDialog = () => {
        setOpen(false);
    };
    return (jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [jsxRuntime.jsx(NerdConfirmContextProvider, Object.assign({ value: { setOpen: _setOpen } }, { children: props.children })), jsxRuntime.jsx(NerdConfirmDialog, { options: Object.assign(Object.assign({}, defaultOptions), options), open: open, closeDialog: closeDialog })] }));
}

const useNerdConfirm = () => {
    const context = React.useContext(NerdConfirmContext);
    return context;
};

/**
 * NerdCodeField: A component that displays multiple inputs for a one-time-code.
 *
 * @param {{length, onChange, value, error, TextfieldProps}} params List of params
 * @returns {React.ReactElement} Returns the CodeField component
 */
function NerdCodeField({ length = 6, onChange, value = "", error = false, TextfieldProps, }) {
    const arrLength = length;
    const [elRefs, setElRefs] = React.useState([]);
    React.useEffect(() => {
        setElRefs((elRefs) => Array(arrLength)
            .fill(0)
            .map((_, i) => elRefs[i] || React.createRef()));
    }, [arrLength]);
    const handleOnPaste = (e) => {
        const pastedValue = e.clipboardData.getData("Text");
        e.stopPropagation();
        e.preventDefault();
        if (/^\d+$/.test(pastedValue)) {
            moveTo(length - 1);
            return onChange(pastedValue.substring(0, length));
        }
    };
    const handleChange = (index) => (e) => {
        const digit = e.target.value.trim(); // single digit keyboard input case
        if (digit === value[index])
            return;
        if (/^\d$/.test(digit)) {
            onChange(value.substring(0, index) + digit + value.substring(index + 1));
            moveToNext(index);
        }
        else if (digit === "") {
            onChange(value.substring(0, index) + " " + value.substring(index + 1));
        }
    };
    const moveTo = (index) => {
        var _a;
        (_a = elRefs[index].current) === null || _a === void 0 ? void 0 : _a.focus();
    };
    const moveToNext = (index) => {
        var _a;
        if (index < length - 1)
            (_a = elRefs[index + 1].current) === null || _a === void 0 ? void 0 : _a.focus();
    };
    const moveToPrevious = (index) => {
        var _a;
        if (index > 0)
            (_a = elRefs[index - 1].current) === null || _a === void 0 ? void 0 : _a.focus();
    };
    const handleKeyUp = (t) => (e) => {
        if (e.code == "ArrowRight") {
            // keyboard right arrow
            moveToNext(t);
        }
        else if (e.code == "ArrowLeft") {
            // keyboard left arrow
            moveToPrevious(t);
        }
        else if (e.code == "Backspace") {
            // delete
            moveToPrevious(t);
        }
        else if (/^\d$/.test(e.key) && e.key === value[t]) {
            moveToNext(t);
        }
    };
    return (jsxRuntime.jsx(material.Box, Object.assign({ sx: { display: "flex", gap: 1 } }, { children: [...Array(length).keys()].map((t) => (React.createElement(material.TextField, Object.assign({ placeholder: "X" }, TextfieldProps, { inputRef: elRefs[t], key: t, autoFocus: value.length === 0 ? t === 0 : t === value.length - 1, onFocus: (event) => {
                event.target.select();
            }, onKeyUp: handleKeyUp(t), inputProps: {
                inputtype: "numeric",
                onPaste: t === 0 ? handleOnPaste : undefined,
                pattern: "[0–9]*",
                maxLength: 1,
                autoComplete: t === 0 ? "one-time-code" : "off",
                style: {
                    textAlign: "center",
                },
            }, error: error, value: value.length >= t && value[t] !== " " && value[t] !== undefined
                ? value[t]
                : "", onChange: handleChange(t) })))) })));
}

exports.ConditionalWrapper = ConditionalWrapper;
exports.NerdAppsMenu = NerdAppsMenu;
exports.NerdAutoComplete = NerdAutoComplete;
exports.NerdCard = NerdCard;
exports.NerdClickToCopy = NerdClickToCopy;
exports.NerdCodeField = NerdCodeField;
exports.NerdConfirmContext = NerdConfirmContext;
exports.NerdConfirmContextProvider = NerdConfirmContextProvider;
exports.NerdConfirmProvider = NerdConfirmProvider;
exports.NerdDataGrid = NerdDataGrid;
exports.NerdHeading = NerdHeading;
exports.NerdHelp = NerdHelp;
exports.NerdIcon = NerdIcon;
exports.NerdInput = NerdInput;
exports.NerdNotifier = NerdNotifier;
exports.NerdPagination = NerdPagination;
exports.PaperComponentOnLoad = PaperComponentOnLoad;
exports.RenderTemplate = RenderTemplate;
exports.clearNotification = clearNotification;
exports.colorSwitch = colorSwitch;
exports.nerdUII18n = i18n;
exports.notificationInitialState = notificationInitialState;
exports.notificationReducer = notificationReducer;
exports.notificationSlice = notificationSlice;
exports.setAxeValue = setAxeValue;
exports.setCustomIconDefinition = setCustomIconDefinition;
exports.showNotification = showNotification;
exports.uid = uid;
exports.useNerdConfirm = useNerdConfirm;
//# sourceMappingURL=index.js.map
