import { SyntheticEvent } from "react";
import { AutocompleteType } from "../nerdInput/nerdInputEnums";
export interface INerdAutoComplete {
    itemID: string;
    value: string;
    fullWidth?: boolean;
    onChange: (event: SyntheticEvent<Element, Event>, newValue: any) => void;
    onInputChange: (event: SyntheticEvent<Element, Event>, newInputValue: any) => void;
    inputValue: string;
    label: string;
    placeholder: string;
    options: any[];
    variant?: "standard" | "outlined" | "filled";
    required?: boolean;
    helperText?: React.ReactNode;
    loading?: boolean;
    autocompleteType?: AutocompleteType.CUSTOMER | AutocompleteType.ADDRESS;
    icon?: React.ReactNode;
    spacing?: number;
    alignItems?: "flex-start" | "center" | "flex-end";
    disabled?: boolean;
    inputSize?: number;
    autoCompleteOptionLabel?: string;
    className?: unknown;
    isEditable?: boolean;
}
export declare type WrapperCustomerOnloadProps = {
    children?: React.ReactNode;
};
